Python在线运行

版本:
运行结果
教程手册
代码仓库
极速运行
交互输入
极速运行模式,更高效的运行,点击编辑器上方的运行按钮即刻体验吧。
以下是用户最新保存的代码
学习python的点点滴滴 发布于:2022-01-28 21:49 小星星python 发布于:2022-01-17 21:12 多行字符串和级联字符串 发布于:2022-01-10 11:21 判断字符串 发布于:2022-01-10 10:25 字符串截取 发布于:2022-01-10 09:24 亨利猜单词 发布于:2022-01-09 22:21 杭州八校联考2021期中信息技术15题 发布于:2022-01-06 13:44 6.转义字符和原字符 发布于:2021-12-30 23:39 5.将数据输出到文件中 发布于:2021-12-30 23:39 简单的笔记 发布于:2021-12-29 15:32 转义字符的使用 发布于:2021-12-29 12:52 音乐爬取python 发布于:2021-12-23 18:06 EDG牛逼! 发布于:2021-12-17 22:03 Data Frame类对象 Index索引 loc既包含起始索引又包含结束索引 i loc只包含起始索引 发布于:2021-12-14 17:37 DateFrame二维数组 index索引 发布于:2021-12-14 17:49 学习通爬虫 发布于:2021-12-13 22:47 矩阵创建 1.矩阵函数 np.mat和np.matrix等价 2.np.array使用二维数组代替矩阵,常见的操作通用 3.shape属性获取矩阵大小 4.单位阵的创建I=np.eye() 5.获取矩阵的某一行a[ ] 6.获取矩阵的某一列line13 7.获取矩阵某个元素 发布于:2021-12-07 20:28 输出1到100之间所有的质数 发布于:2021-12-07 17:37 用列表编程,输入一个包含若干整数的列表,输出由其中的偶数组成的新列表 发布于:2021-12-07 17:33 用列表编程,输入两个包含若干整数的等长列表表示的两个向量,输出这两个向量的内积,并分别输出两个向量的最大值最小值的下标组成的列表 发布于:2021-12-07 17:44 编写程序,从键盘输入矩形的长和宽,并输出矩形面积 发布于:2021-12-07 17:15 数组创建/初始化numpy.linspace(start, stop[, num=50[, endpoint=True[, retstep=False[, dtype=None]]]]]) num - 元素个数,默认为50 endpoint - 是否包含stop数值,默认为True,包含stop值;若为False,则不包含stop值 retstep - 返回值形式,默认为False,返回等差数列组,若为True,则返回结果(array([samples, step])), return 在指定范围内的均匀间隔的数字(组成的数组),也即返回一个等差数列 发布于:2021-12-07 18:57 随机生成一个二维数组np.random.rand() 发布于:2021-12-07 16:51 矩阵乘法dot() 计算对角线元素和trace() 计算矩阵行列式det() 一维数组形式放回方针对角线diag() 计算方针的逆inv() 发布于:2021-12-07 16:44 hill解密 发布于:2021-12-02 08:38 RSA加密 发布于:2021-11-30 19:56 转换格式+输出最大.imag最小值.real+ 发布于:2021-12-07 16:14 numpy数组 15:随机数数组 22:等差数组【range()返回的是列表】 发布于:2021-12-14 17:40 序列密码完 发布于:2021-11-26 19:57 针对某个判定条件,一次成功就不回溯 发布于:2021-11-24 12:38 爱心函数zm 发布于:2021-11-23 17:38 des加密 发布于:2021-11-23 16:31 hill密码 发布于:2021-11-23 14:11 维吉尼亚密码破解 发布于:2021-12-27 14:00 维吉尼亚密码加密解密 发布于:2021-12-27 11:18 学生类实现一些方法 发布于:2021-11-15 09:53 修改字符串中的字母 发布于:2021-11-15 09:25 去除html标记 发布于:2021-11-15 09:21 输出长度为3的单词 发布于:2021-11-15 09:17 去除多余单词 发布于:2021-11-15 09:13 利用函数模拟报数游戏 发布于:2021-11-15 09:00 查找给定序列的最长递增子序列 发布于:2021-11-15 08:52 打印一个列表中数字的平方和 发布于:2021-11-15 08:49 判断密码强度 发布于:2021-11-15 08:39 22题 2021-11-12 解决数学问题 发布于:2021-11-12 21:14 一键批量生成随机数(Python) 发布于:2021-11-07 16:35 数据提取-1  请你通过所学知识,把列表list1中的'love'取出来,并打印出来。  数据提取-2  请你通过所学知识,把字典dict1中的'love'取出来,并打印出来。  拓展知识:元组  下面,介绍一种新的数据类型:元组(tuple)。 可以看到:元组和表格很相似,不过,它是用小括号来包的。 元组和列表都是序列,提取的方式也是偏移量,如 tuple1[1]、tuple1[1:]。另外,元组也支持任意的嵌套。 请你根据以上提供的信息,将tuple1中的A和list2中的D打印出来。看到了,理解了,运用了,就能够掌握了。 发布于:2021-11-06 20:47 如何取出字典里的值了。删除字典里键值对的代码是del语句del 字典名[键],而新增键值对要用到赋值语句字典名[键] = 值。两者数据读取方法会不同的原因:列表有序,要用偏移量定位;字典无序,便通过唯一的键来取值。 发布于:2021-11-06 20:05 列表提取,增加删除元素 发布于:2021-11-06 15:38 append后的括号里只能接受一个参数,但却给了两个,也就是4和5。所以,用append()给列表增加元素,每次只能增加一个元素。 发布于:2021-11-06 15:23 [更多]
显示目录

错误和异常



Python 错误和异常

作为Python初学者,在刚学习Python编程时,经常会看到一些报错信息,在前面我们没有提及,这章节我们会专门介绍。

Python有两种错误很容易辨认:语法错误和异常。

语法错误

Python 的语法错误或者称之为解析错,是初学者经常碰到的,如下实例

>>> while True print('Hello world')
  File "<stdin>", line 1, in ?
    while True print('Hello world')
                   ^
SyntaxError: invalid syntax

这个例子中,函数 print() 被检查到有错误,是它前面缺少了一个冒号(:)。

语法分析器指出了出错的一行,并且在最先找到的错误的位置标记了一个小小的箭头。

异常

即便Python程序的语法是正确的,在运行它的时候,也有可能发生错误。运行期检测到的错误被称为异常。

大多数的异常都不会被程序处理,都以错误信息的形式展现在这里:

>>> 10 * (1/0)
Traceback (most recent call last):
  File "<stdin>", line 1, in ?
ZeroDivisionError: division by zero
>>> 4 + spam*3
Traceback (most recent call last):
  File "<stdin>", line 1, in ?
NameError: name 'spam' is not defined
>>> '2' + 2
Traceback (most recent call last):
  File "<stdin>", line 1, in ?
TypeError: Can't convert 'int' object to str implicitly

异常以不同的类型出现,这些类型都作为信息的一部分打印出来: 例子中的类型有 ZeroDivisionError,NameError 和 TypeError。

错误信息的前面部分显示了异常发生的上下文,并以调用栈的形式显示具体信息。

异常处理

以下例子中,让用户输入一个合法的整数,但是允许用户中断这个程序(使用 Control-C 或者操作系统提供的方法)。用户中断的信息会引发一个 KeyboardInterrupt 异常。

>>> while True:
        try:
            x = int(input("Please enter a number: "))
            break
        except ValueError:
            print("Oops!  That was no valid number.  Try again   ")

try语句按照如下方式工作;

  • 首先,执行try子句(在关键字try和关键字except之间的语句)
  • 如果没有异常发生,忽略except子句,try子句执行后结束。
  • 如果在执行try子句的过程中发生了异常,那么try子句余下的部分将被忽略。如果异常的类型和 except 之后的名称相符,那么对应的except子句将被执行。最后执行 try 语句之后的代码。
  • 如果一个异常没有与任何的except匹配,那么这个异常将会传递给上层的try中。

一个 try 语句可能包含多个except子句,分别来处理不同的特定的异常。最多只有一个分支会被执行。

处理程序将只针对对应的try子句中的异常进行处理,而不是其他的 try 的处理程序中的异常。

一个except子句可以同时处理多个异常,这些异常将被放在一个括号里成为一个元组,例如:

 except (RuntimeError, TypeError, NameError):
        pass

最后一个except子句可以忽略异常的名称,它将被当作通配符使用。你可以使用这种方法打印一个错误信息,然后再次把异常抛出。

import sys

try:
    f = open('myfile.txt')
    s = f.readline()
    i = int(s.strip())
except OSError as err:
    print("OS error: {0}".format(err))
except ValueError:
    print("Could not convert data to an integer.")
except:
    print("Unexpected error:", sys.exc_info()[0])
    raise

try except 语句还有一个可选的else子句,如果使用这个子句,那么必须放在所有的except子句之后。这个子句将在try子句没有发生任何异常的时候执行。例如:

for arg in sys.argv[1:]:
    try:
        f = open(arg, 'r')
    except IOError:
        print('cannot open', arg)
    else:
        print(arg, 'has', len(f.readlines()), 'lines')
        f.close()

使用 else 子句比把所有的语句都放在 try 子句里面要好,这样可以避免一些意想不到的、而except又没有捕获的异常。

异常处理并不仅仅处理那些直接发生在try子句中的异常,而且还能处理子句中调用的函数(甚至间接调用的函数)里抛出的异常。例如:

>>> def this_fails():
        x = 1/0

>>> try:
        this_fails()
    except ZeroDivisionError as err:
        print('Handling run-time error:', err)

Handling run-time error: int division or modulo by zero

抛出异常

Python 使用 raise 语句抛出一个指定的异常。例如:

>>> raise NameError('HiThere')
Traceback (most recent call last):
  File "<stdin>", line 1, in ?
NameError: HiThere

raise 唯一的一个参数指定了要被抛出的异常。它必须是一个异常的实例或者是异常的类(也就是 Exception 的子类)。

如果你只想知道这是否抛出了一个异常,并不想去处理它,那么一个简单的 raise 语句就可以再次把它抛出。

>>> try:
        raise NameError('HiThere')
    except NameError:
        print('An exception flew by!')
        raise

An exception flew by!
Traceback (most recent call last):
  File "<stdin>", line 2, in ?
NameError: HiThere

用户自定义异常

你可以通过创建一个新的exception类来拥有自己的异常。异常应该继承自 Exception 类,或者直接继承,或者间接继承,例如:

>>> class MyError(Exception):
        def __init__(self, value):
            self.value = value
        def __str__(self):
            return repr(self.value)

>>> try:
        raise MyError(2*2)
    except MyError as e:
        print('My exception occurred, value:', e.value)

My exception occurred, value: 4
>>> raise MyError('oops!')
Traceback (most recent call last):
  File "<stdin>", line 1, in ?
__main__.MyError: 'oops!'

在这个例子中,类 Exception 默认的 __init__() 被覆盖。

异常的类可以像其他的类一样做任何事情,但是通常都会比较简单,只提供一些错误相关的属性,并且允许处理异常的代码方便的获取这些信息。

当创建一个模块有可能抛出多种不同的异常时,一种通常的做法是为这个包建立一个基础异常类,然后基于这个基础类为不同的错误情况创建不同的子类:

class Error(Exception):
    """Base class for exceptions in this module."""
    pass

class InputError(Error):
    """Exception raised for errors in the input.

    Attributes:
        expression -- input expression in which the error occurred
        message -- explanation of the error
    """

    def __init__(self, expression, message):
        self.expression = expression
        self.message = message

class TransitionError(Error):
    """Raised when an operation attempts a state transition that's not
    allowed.

    Attributes:
        previous -- state at beginning of transition
        next -- attempted new state
        message -- explanation of why the specific transition is not allowed
    """

    def __init__(self, previous, next, message):
        self.previous = previous
        self.next = next
        self.message = message

大多数的异常的名字都以"Error"结尾,就跟标准的异常命名一样。


定义清理行为

try 语句还有另外一个可选的子句,它定义了无论在任何情况下都会执行的清理行为。 例如:

>>> try:
        raise KeyboardInterrupt
    finally:
        print('Goodbye, world!')

Goodbye, world!
KeyboardInterrupt

以上例子不管try子句里面有没有发生异常,finally子句都会执行。

如果一个异常在 try 子句里(或者在 except 和 else 子句里)被抛出,而又没有任何的 except 把它截住,那么这个异常会在 finally 子句执行后再次被抛出。

下面是一个更加复杂的例子(在同一个 try 语句里包含 except 和 finally 子句):

>>> def divide(x, y):
        try:
            result = x / y
        except ZeroDivisionError:
            print("division by zero!")
        else:
            print("result is", result)
        finally:
            print("executing finally clause")

>>> divide(2, 1)
result is 2.0
executing finally clause
>>> divide(2, 0)
division by zero!
executing finally clause
>>> divide("2", "1")
executing finally clause
Traceback (most recent call last):
  File "<stdin>", line 1, in ?
  File "<stdin>", line 3, in divide
TypeError: unsupported operand type(s) for /: 'str' and 'str'

预定义的清理行为

一些对象定义了标准的清理行为,无论系统是否成功的使用了它,一旦不需要它了,那么这个标准的清理行为就会执行。

这面这个例子展示了尝试打开一个文件,然后把内容打印到屏幕上:

for line in open("myfile.txt"):
    print(line, end="")

以上这段代码的问题是,当执行完毕后,文件会保持打开状态,并没有被关闭。

关键词 with 语句就可以保证诸如文件之类的对象在使用完之后一定会正确的执行他的清理方法:

with open("myfile.txt") as f:
    for line in f:
        print(line, end="")

以上这段代码执行完毕后,就算在处理过程中出问题了,文件 f 总是会关闭。

由JSRUN为你提供的Python在线运行、在线编译工具
        JSRUN提供的Python在线运行,Python 在线运行工具,基于linux操作系统环境提供线上编译和线上运行,具有运行快速,运行结果与常用开发、生产环境保持一致的特点。

title

使用此草稿 删除草稿

  • 00:23
注册登录后可减少验证码的弹出,点击前往 注册 | 登录

皮肤:

运行模式:

嵌入代码 iframe嵌入:


服务器已安装大部分常用的第依赖库,但仍可能存在一些未被安装的库, 可以通过本窗口立即安装所需依赖库。


请输入依赖库的名称:

请选择语言: